#include <iostream>
#include <stack>
#include <memory>
#include <queue>
#include <algorithm>
#define student shared_ptr<Student>
#define school shared_ptr<School>

using namespace std;
using ll = long long int;

struct School;

struct Student{
    school prio1;
    school prio2;
    int score;

    Student(const shared_ptr<School> &prio1, const shared_ptr<School> &prio2, int score,
            const shared_ptr<School> &currSchool) : prio1(prio1), prio2(prio2), score(score), currSchool(currSchool) {}

    school currSchool;
};

struct Compare {
public:
    bool operator () (const student & a, const student & b) {
        return a->score > b->score;
    }
};


struct School{
    explicit School(int id) : id(id){
    }

    priority_queue<student, vector<student>, Compare> l;
    int id;

};




int main(){
    int n,m,c;
    cin >> n >> m >> c;
    vector<school> schools;
    vector<student> students;
    for (int i = 0; i < m+1; ++i) {
        schools.emplace_back(make_shared<School>(School(i)));
    }
    for (int i = 0; i < n; ++i) {
        int p1, p2;
        cin >> p1 >> p2;
        students.emplace_back(make_shared<Student>(Student(schools[p1-1], schools[p2-1], i, nullptr)));
    }
    reverse(students.begin(), students.end());

    bool valid = true;
    while(valid) {
        valid = false;

        for (auto sch : schools) {

            for (auto stud : students) {

                if(stud -> prio1 != sch && stud -> prio2 != sch ) continue;
                if(sch->l.size()>= c && stud->score < sch->l.top()->score) continue;
                if(stud->currSchool != nullptr && stud->currSchool == stud-> prio1) continue;
                valid = true;
                if(sch->l.size() == c) {
                    sch->l.pop();
                }
                sch->l.emplace(stud);
                stud->currSchool = sch;

            }
        }
    }
    int first = 0, second = 0;
    for(auto s : students) {
        if(s->currSchool == s->prio1) {
            first++;
        } else if(s->currSchool == s->prio2) {
            second++;
        }
    }
    cout << first << " " << second << endl;


    return 0;
}//
// Created by cteam25 on 10/21/23.
//
